{=======================================================}
{                                                       }
{     <<Mirro For Delphi>> Intenet Demo  Recv         }
{                                                       }
{        (c)Copyright 2005,www.138soft.com              }
{                                                       }
{=======================================================}

unit URecv;

{=======================================================
  Project : <Mirro For Delphi>> Intenet Demo  Recv
  Module  : Main Form
  Describe: (None)
  Version : 1.0
  Data    : 2005-11-12
  Author  : Chen JingTao,http://www.138soft.com,lovejingtao@21cn.com
  Update  : 2005-11-12
=======================================================}

interface

uses
  Windows, Messages, SysUtils, Jpeg, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdAntiFreezeBase, IdAntiFreeze, IdThreadMgr, IdThreadMgrDefault,
  IdBaseComponent, IdComponent, IdTCPServer;
const
  WM_DRAWTHEBMP = WM_USER + 3;
type
  TForm1 = class(TForm)
    IdTCPServer1: TIdTCPServer;
    IdThreadMgrDefault1: TIdThreadMgrDefault;
    IdAntiFreeze1: TIdAntiFreeze;
    procedure FormCreate(Sender: TObject);
    procedure IdTCPServer1Execute(AThread: TIdPeerThread);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure IdTCPServer1Connect(AThread: TIdPeerThread);
  private
    { Private declarations }
    procedure MyDrawTheBmp(var Msg: TMessage); message WM_DRAWTHEBMP;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  MyRect: TRect;
  MyBmp: TBitmap;
  MyJpg: TJPEGImage;
  MyStream: TMemoryStream;

implementation

uses
  UCommon, IdGlobal;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  try
    IdTCPServer1.DefaultPort := iTcpPort;
    IdTCPServer1.Active := True;
  except
    ShowMessage('Port Err!');
    Application.Terminate;
    Exit;
  end;
  MyBmp := TBitmap.Create;
  MyJpg := TJPEGImage.Create;
  MyStream := TMemoryStream.Create;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MyBmp.Free;
  MyJpg.Free;
  MyStream.Free;
end;

procedure TForm1.IdTCPServer1Connect(AThread: TIdPeerThread);
begin
  Application.Restore;
  ShowWindow(Handle, SW_SHOW);
  SetForegroundWindow(Handle);
end;

procedure TForm1.MyDrawTheBmp(var Msg: TMessage);
begin
  Canvas.StretchDraw(MyRect, MyBmp);
  InvalidateRect(Handle, @MyRect, FALSE);
end;

procedure TForm1.IdTCPServer1Execute(AThread: TIdPeerThread);
var
  strCmd: string;
  iLeft, iTop, iRight, iBottom, iSize: integer;
begin
  try
    strCmd := AThread.Connection.ReadLn(EOL + EOL);
  except
    AThread.Connection.Disconnect;
    AThread.Terminate;
    Exit;
  end;
  if strCmd = COMMAND_DATA then
  begin
    try
      iLeft := AThread.Connection.ReadInteger;
      iTop := AThread.Connection.ReadInteger;
      iRight := AThread.Connection.ReadInteger;
      iBottom := AThread.Connection.ReadInteger;
      iSize := AThread.Connection.ReadInteger;
      MyStream.Clear;
      AThread.Connection.ReadStream(MyStream, iSize);
    except
      PostMessage(Handle, WM_CLOSE, 0, 0);
      Exit;
    end;
    MyStream.Position := 0;
    MyJpg.LoadFromStream(MyStream);
    MyBmp.Assign(MyJpg);
    SetRect(MyRect, iLeft, iTop, iRight, iBottom);
    PostMessage(Handle, WM_DRAWTHEBMP, 0, 0);
  end;
end;

end.

